## interface99 1.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11.4)
project(interface99 LANGUAGES C)

# Fix the warnings about `DOWNLOAD_EXTRACT_TIMESTAMP` in newer CMake versions.
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
    cmake_policy(SET CMP0135 NEW)
endif()

include(FetchContent)

FetchContent_Declare(
    metalang99
    URL https://github.com/Hirrolot/metalang99/archive/refs/tags/v1.13.2.tar.gz
)

FetchContent_MakeAvailable(metalang99)

add_library(${PROJECT_NAME} INTERFACE)
target_include_directories(${PROJECT_NAME} INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} INTERFACE metalang99)

=== tests/extern_impl/CMakeLists.txt ===
add_executable(test test.c impl.c types.h ../common.h ../common.c ../util.h)

=== debian/changelog ===
interface99 (1.0.1-1) unstable; urgency=medium

  * Initial release.

 -- Roland Mas <lolando@debian.org>  Tue, 27 Feb 2024 18:12:22 +0100

## interface99 1.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.11.4)
+cmake_minimum_required(VERSION 3.10.0)
 project(interface99 LANGUAGES C)
 
 # Fix the warnings about `DOWNLOAD_EXTRACT_TIMESTAMP` in newer CMake versions.
@@ -10,7 +10,7 @@
 
 FetchContent_Declare(
     metalang99
-    URL https://github.com/Hirrolot/metalang99/archive/refs/tags/v1.13.2.tar.gz
+    URL https://github.com/hirrolot/metalang99/archive/refs/tags/v1.13.5.tar.gz
 )
 
 FetchContent_MakeAvailable(metalang99)

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(examples LANGUAGES C)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-Wall -Wextra -pedantic -ftrack-macro-expansion=0
                      -fsanitize=address)
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(-fmacro-backtrace-limit=1 -fsanitize=address)
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  # Enable a standard-conforming C99/C11 preprocessor.
  add_compile_options("/std:c11")
elseif(CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
  add_compile_definitions(ML99_ALLOW_POOR_DIAGNOSTICS)
endif()

add_subdirectory(opaque_type)

add_executable(shape shape.c)
add_executable(tracing_vehicle tracing_vehicle.c)
add_executable(airplane airplane.c)
add_executable(read_write read_write.c)
add_executable(read_write_both read_write_both.c)
add_executable(marker marker.c)
add_executable(default_impl default_impl.c)

add_subdirectory(.. build)

get_property(
  EXAMPLES
  DIRECTORY .
  PROPERTY BUILDSYSTEM_TARGETS)

get_property(
  OPAQUE_TYPE_EXAMPLE
  DIRECTORY opaque_type
  PROPERTY BUILDSYSTEM_TARGETS)

foreach(TARGET ${EXAMPLES};${OPAQUE_TYPE_EXAMPLE})
  target_link_libraries(${TARGET} interface99)
  set_target_properties(${TARGET} PROPERTIES C_STANDARD 99 C_STANDARD_REQUIRED
                                                           ON)
endforeach()

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(tests LANGUAGES C)

if(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  add_compile_options(-Wall -Wextra -pedantic -ftrack-macro-expansion=0
                      -fsanitize=address)
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  add_compile_options(-fmacro-backtrace-limit=1 -fsanitize=address)
  add_link_options(-fsanitize=address)
elseif(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  # Enable a standard-conforming C99/C11 preprocessor.
  add_compile_options("/std:c11")
elseif(CMAKE_C_COMPILER_ID STREQUAL "TinyCC")
  add_compile_definitions(ML99_ALLOW_POOR_DIAGNOSTICS)
endif()

add_subdirectory(extern_impl)

add_executable(basic_tests basic_tests.c common.h common.c util.h)
add_executable(vcalls vcalls.c)
add_executable(decl_impl decl_impl.c common.h common.c)
add_executable(metalang99_compliant metalang99_compliant.c)
add_executable(superinterfaces superinterfaces.c common.h common.c util.h)
add_executable(default_impl default_impl.c)
add_executable(version version.c)

add_subdirectory(.. build)

get_property(
  TESTS
  DIRECTORY .
  PROPERTY BUILDSYSTEM_TARGETS)

get_property(
  EXTERN_IMPL_TESTS
  DIRECTORY extern_impl
  PROPERTY BUILDSYSTEM_TARGETS)

foreach(TARGET ${TESTS};${EXTERN_IMPL_TESTS})
  target_link_libraries(${TARGET} interface99)
  set_target_properties(${TARGET} PROPERTIES C_STANDARD 99 C_STANDARD_REQUIRED
                                                           ON)
endforeach()

=== examples/opaque_type/CMakeLists.txt ===
add_executable(frog main.c frog.h frog.c croak.h)

=== debian/changelog ===
interface99 (1.0.2-1) unstable; urgency=medium

  * Import upstream version 1.0.2.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sat, 04 Oct 2025 22:02:01 +0200

=== debian/control ===
Source: interface99
Section: devel
Priority: optional
Maintainer: Roland Mas <lolando@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libmetalang99-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/Hirrolot/interface99
Vcs-Browser: https://salsa.debian.org/science-team/interface99
Vcs-Git: https://salsa.debian.org/science-team/interface99.git

Package: libinterface99-dev
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libmetalang99-dev,
Description: Full-featured interfaces for C99
 Full-featured interfaces inspired by Rust and Golang. Multiple
 inheritance, superinterfaces, and default implementations
 supported. No external tools required, pure C99.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_installdocs:
	dh_installdocs -X.gitignore

execute_after_dh_auto_test:
	cmake -S tests -B testsbuild && make -C testsbuild

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/Hirrolot/interface99/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
